/**
 * PicoLCD 256x64 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#if !defined(AFX_HIDINTERFACE_H__27FBB2E6_FCE2_4860_9AFB_C27E5C6DA74E__INCLUDED_)
#define AFX_HIDINTERFACE_H__27FBB2E6_FCE2_4860_9AFB_C27E5C6DA74E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "utils/HArray.h"
class HIDDevice;

class HIDInterface
{
public:
	HIDInterface(HIDDevice* hdev);
	virtual ~HIDInterface();

	virtual void Received(HArray* array)=0;
	void WriteArray(HArray* array);

	void OpenDevice();
	void CloseDevice();

	bool isConnected();

	virtual void DeviceDisconnected()=0;//should be overwritten if notification required about device disconnection

protected:
	HIDDevice* m_pParent;
};

#endif // !defined(AFX_HIDINTERFACE_H__27FBB2E6_FCE2_4860_9AFB_C27E5C6DA74E__INCLUDED_)
