/**
 * PicoLCD 256x64 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include "..\HIDMiniBoxDev.h"

// CCardLCD dialog

class CCardLCD : public CPropertyPage
{
	DECLARE_DYNAMIC(CCardLCD)

public:
	CCardLCD();
	virtual ~CCardLCD();

// Dialog Data
	enum { IDD = IDD_CARD_LCD };

protected:
	int GetSplashMaxSize();
	int GetSplashSize();
	bool loadBitmap(CString str, TSCREEN* screen);

	CString m_strLastBitmapFile;
	CString m_strLCD;
	UINT_PTR m_nTimer;
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	void SendInitialValues();
	void SendContrast();
	void SendBacklight();

	bool SendBitmap(CString str);

	void UpdateKeys(int n1, int n2);
	int m_nKeys[2];

    CDC m_dcMem;            // Compatible Memory DC for dialog
    HBITMAP m_hBmpNew;		// Handle of new bitmap from file
    BITMAP m_bmInfo;        // Bitmap Information structure

	CSliderCtrl m_sliderContrast;
	CSliderCtrl m_sliderBacklight;
	CStatic m_staticKey[8];
	
	virtual BOOL OnInitDialog();
	afx_msg void OnNMReleasedcaptureSliderContrast(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMReleasedcaptureSliderBrightness(NMHDR *pNMHDR, LRESULT *pResult);
	virtual BOOL DestroyWindow();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnPaint();
	afx_msg void OnBnClickedButtonReload();
	afx_msg void OnBnClickedButtonToflasher();
	afx_msg void OnBnClickedButtonSplash();
};
