/**
 * PicoLCD 256x64 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */

#include "stdafx.h"
#include "MiniBoxDev.h"
#include "CompareDlg.h"


// CCompareDlg dialog

IMPLEMENT_DYNAMIC(CCompareDlg, CDialog)

/////////////////////////////////////////////////////////////////////////////
// CCompareDlg dialog


CCompareDlg::CCompareDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCompareDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCompareDlg)
	m_bFromDev = TRUE;
	m_strFile1 = _T("read.hex");
	m_strFile2 = _T("");
	m_strMax = _T("x8000");
	m_strMin = _T("x2000");
	m_bWriteDump = TRUE;
	//}}AFX_DATA_INIT
}


void CCompareDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCompareDlg)
	DDX_Check(pDX, IDC_CHECK_FROMDEV, m_bFromDev);
	DDX_Text(pDX, IDC_EDIT_FILE1, m_strFile1);
	DDX_Text(pDX, IDC_EDIT_FILE2, m_strFile2);
	DDX_Text(pDX, IDC_EDIT_MEMMAX, m_strMax);
	DDX_Text(pDX, IDC_EDIT_MEMMIN, m_strMin);
	DDX_Check(pDX, IDC_CHECK_WRITEDUMP, m_bWriteDump);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCompareDlg, CDialog)
	//{{AFX_MSG_MAP(CCompareDlg)
	ON_BN_CLICKED(IDC_BUTTON_FILE1, OnButtonFile1)
	ON_BN_CLICKED(IDC_BUTTON_FILE2, OnButtonFile2)
	ON_BN_CLICKED(IDC_CHECK_FROMDEV, OnCheckFromdev)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompareDlg message handlers

void CCompareDlg::OnButtonFile1() 
{
	char BASED_CODE szFilter[] = "Hex files (*.hex)|*.hex|";
	CFileDialog cfd(TRUE,NULL,"*.hex", OFN_OVERWRITEPROMPT | OFN_EXPLORER,  szFilter,this);
	if (cfd.DoModal()==IDOK)
	{
		m_strFile1 = cfd.GetPathName();
	}

	if (GetSafeHwnd()) UpdateData(FALSE);
}

void CCompareDlg::OnButtonFile2() 
{
	char BASED_CODE szFilter[] = "Hex files (*.hex)|*.hex|";
	CFileDialog cfd(TRUE,NULL,"*.hex", OFN_OVERWRITEPROMPT | OFN_EXPLORER,  szFilter,this);
	if (cfd.DoModal()==IDOK)
	{
		m_strFile2 = cfd.GetPathName();
	}

	if (GetSafeHwnd()) UpdateData(FALSE);
}

void CCompareDlg::OnCheckFromdev() 
{
	if (GetSafeHwnd()) UpdateData();
	
	if (m_bFromDev)
	{
		GetDlgItem(IDC_EDIT_FILE1)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON_FILE1)->EnableWindow(FALSE);
		m_strFile1 = "read.hex";
	}
	else
	{
		GetDlgItem(IDC_EDIT_FILE1)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON_FILE1)->EnableWindow(TRUE);

		m_strFile1 = "";
	}

	if (GetSafeHwnd()) UpdateData(FALSE);
}
