/**
 * PicoLCD 256x64 
 * Copyright (C) 2008 mini-box.com
 *
 * Licensed under the terms of the GNU Lesser General Public License v2.1:
 * 		http://www.opensource.org/licenses/lgpl-2.1.php
 *
 * For further information visit:
 * 		http://www.picolcd.com/
 *
 * File Authors:
 * 		Barna Csenteri
 */


#include "stdafx.h"
#include "MiniBoxDev.h"
#include "MiniBoxDevDlg.h"
#include "..\HIDDescriptor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMiniBoxDevDlg dialog




CMiniBoxDevDlg::CMiniBoxDevDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMiniBoxDevDlg::IDD, pParent)
{
	m_pCards				= NULL;
	m_pHIDDevLCD			= NULL;
	m_pHIDInterfaceLCD		= NULL;
	m_hIcon					= AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_nDeviceNo				= -1;
	
	SetDbgLevel(5);
}

void CMiniBoxDevDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMiniBoxDevDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CMiniBoxDevDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CMiniBoxDevDlg::OnBnClickedCancel)
	ON_WM_SIZE()
	ON_COMMAND(WM_DISCONNECTED, OnDisconnected)
END_MESSAGE_MAP()


// CMiniBoxDevDlg message handlers

BOOL CMiniBoxDevDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// ITUNER code

	SetControlParent(this,IDC_STATIC_NODEVICE);

	VERIFY(m_fontMedium.CreateFont(
	   16,                        // nHeight
	   0,                         // nWidth
	   0,                         // nEscapement
	   0,                         // nOrientation
	   FW_NORMAL,                 // nWeight
	   FALSE,                     // bItalic
	   FALSE,                     // bUnderline
	   0,                         // cStrikeOut
	   ANSI_CHARSET,              // nCharSet
	   OUT_DEFAULT_PRECIS,        // nOutPrecision
	   CLIP_DEFAULT_PRECIS,       // nClipPrecision
	   DEFAULT_QUALITY,           // nQuality
	   DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
	   "MS Shell Dlg"));                 // lpszFacename
	VERIFY(m_fontBig.CreateFont(
	   26,                        // nHeight
	   0,                         // nWidth
	   0,                         // nEscapement
	   0,                         // nOrientation
	   FW_NORMAL,				  // nWeight
	   FALSE,                     // bItalic
	   FALSE,                     // bUnderline
	   0,                         // cStrikeOut
	   ANSI_CHARSET,              // nCharSet
	   OUT_DEFAULT_PRECIS,        // nOutPrecision
	   CLIP_DEFAULT_PRECIS,       // nClipPrecision
	   DEFAULT_QUALITY,           // nQuality
	   DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
	   "MS Shell Dlg"));                 // lpszFacename

	m_pCards = new CBaseClassForCards("",this);
	m_pCards->Create(this,WS_CHILD) ;
	PostMessage(WM_SIZE);

	CString strCmdLine(AfxGetApp()->m_lpCmdLine);
	if (strCmdLine != "")
		m_nDeviceNo = atoi(strCmdLine);

	Connect(true);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMiniBoxDevDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMiniBoxDevDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMiniBoxDevDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMiniBoxDevDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

void CMiniBoxDevDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnCancel();
}

BOOL CMiniBoxDevDlg::DestroyWindow()
{
	//delete socket

	if (m_pHIDInterfaceLCD)
	{
		delete m_pHIDInterfaceLCD;
		m_pHIDInterfaceLCD = NULL;
	}

	/*if (m_pHIDInterfaceInstall)
	{
		delete m_pHIDInterfaceInstall;
		m_pHIDInterfaceInstall = NULL;
	}*/

	if (m_pHIDDevLCD)
	{
		delete m_pHIDDevLCD;
		m_pHIDDevLCD = NULL;
	}

	if (m_pCards) delete m_pCards;
	m_pCards = NULL;

	return CDialog::DestroyWindow();
}

void CMiniBoxDevDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	CRect rect;
	GetClientRect(&rect);

	if (GetSafeHwnd() && m_pCards && m_pCards->GetSafeHwnd())
	{
		m_pCards->MoveWindow(rect,TRUE);//rect.Height()-250//5,210,rect.Width(),100
	}
}

void CMiniBoxDevDlg::Connect(bool mbox)
{
	if (GetSafeHwnd())
	{
		GetDlgItem(IDC_STATIC_NODEVICE)->ShowWindow(SW_SHOW);
		m_pCards->ShowWindow(SW_HIDE);
	}

	if (!m_pHIDInterfaceLCD)
	{
		HIDDescriptor* hdesc = m_devices.chooseHIDDevice(MANUFACTURER, PROD_LCD, PROD_FLASH, 0x4d8, -1, m_nDeviceNo, HIDDevices::DEV_TYPE_LCD);
		TRACE("hdesc=%x\n",hdesc);
		if (hdesc)
		{
	//		MyTrace(1, "You choose %s\n", hdesc->m_interfaceDetailData->DevicePath);
	//		m_pHIDInterface = m_devices.openAcme(hdesc, this);
			if (m_pHIDDevLCD) delete m_pHIDDevLCD;
			m_pHIDDevLCD = NULL;

			m_pHIDDevLCD = m_devices.openDevice(hdesc);
			m_pHIDInterfaceLCD = new HIDMiniBoxDev(HIDDevices::DEV_TYPE_LCD, m_pHIDDevLCD, TIMEOUT);
			m_pHIDInterfaceLCD->connectGraph(this);

			TRACE(" dev=%x acme=%x\n",m_pHIDDevLCD, m_pHIDInterfaceLCD);

			CString strver;strver.Format("%02d.%02d", m_pHIDInterfaceLCD->m_nVersion[0], m_pHIDInterfaceLCD->m_nVersion[1]);
			SetWindowText(CString(hdesc->m_sProduct)+" version:"+strver);
			
			if (m_pHIDInterfaceLCD->isFlasher())
			{
				m_pCards->CheckPages(true);
				m_pCards->m_pCardFlash->FillActionList(true);
			}
			else
			{
				m_pCards->CheckPages(false);
				m_pCards->m_pCardLCD->SendInitialValues();
				m_pCards->m_pCardFlash->FillActionList(false);
			}

			if (GetSafeHwnd())
			{
				GetDlgItem(IDC_STATIC_NODEVICE)->ShowWindow(SW_HIDE);
				m_pCards->ShowWindow(SW_SHOW);
			}
		}
		else
		{
			if (mbox) AfxMessageBox("Device not found!\nClose any programs using the device and/or uninstall Sideshow driver if you have one!");
			SetWindowText("Device not found!");
		}
	}
	else if (mbox) AfxMessageBox("Already connected\n");
}

void CMiniBoxDevDlg::SwitchMode()
{
	if (!m_pHIDInterfaceLCD)
	{
		AfxMessageBox("Connect first!");
		return;
	}
	
	int res = AfxMessageBox("Are you sure you want to switch the mode?", MB_YESNO|MB_ICONSTOP);
	if (res == IDYES)
	{
		CWaitCursor cursor;
		m_pHIDInterfaceLCD->switchMode();

		if (m_pHIDInterfaceLCD) delete m_pHIDInterfaceLCD;
		m_pHIDInterfaceLCD = NULL;

		if (m_pHIDDevLCD) delete m_pHIDDevLCD;
		m_pHIDDevLCD = NULL;

		Sleep(5000+1000);

//		AfxMessageBox("You have to restart the program!");
//		OnCancel();
		for (int i=0;i<5;i++)
		{
			TRACE("Reconnecting %d\n", i);

			CString strDevice;
			strDevice.Format("Reconnecting %d ...",i);
			SetWindowText(strDevice);

			UpdateData(FALSE);
			RedrawWindow();

			if (m_pHIDInterfaceLCD) delete m_pHIDInterfaceLCD;
			m_pHIDInterfaceLCD = NULL;

			if (m_pHIDDevLCD) delete m_pHIDDevLCD;
			m_pHIDDevLCD = NULL;

			Connect(false);

			if ((m_pHIDInterfaceLCD != NULL)&&(m_pHIDInterfaceLCD->isWOK()))
			{
				TRACE("Connected \n");
				i = 100;
			}
			else
			{
				TRACE("Not Connected %d\n", i);
				Sleep(2000);
			}
		}

		UpdateData(FALSE);
		RedrawWindow();

		if (m_pHIDInterfaceLCD && m_pHIDInterfaceLCD->isWOK())
		{
			//connected
			TRACE("CONNECTED!!!\n");
		}
		else
		{
			TRACE("Reconnecting final\n");

			SetWindowText("Reconnecting FINAL ...");

			UpdateData(FALSE);
			RedrawWindow();

			if (m_pHIDInterfaceLCD) delete m_pHIDInterfaceLCD;
			m_pHIDInterfaceLCD = NULL;

			if (m_pHIDDevLCD) delete m_pHIDDevLCD;
			m_pHIDDevLCD = NULL;

			Connect(true);

			if (!m_pHIDInterfaceLCD)
			{
				AfxMessageBox("Device could not be restarted! The program has to be restarted!");
				//EndDialog(0);
			}
		}
	}
}

void CMiniBoxDevDlg::OnDisconnected()
{
	TRACE("STATUS DISCONNECTED MESSAGE 1\n");
	if (GetSafeHwnd())
	{
		if (m_pHIDInterfaceLCD && m_pHIDInterfaceLCD->isWOK() && m_pHIDInterfaceLCD->isConnected())
		{
			GetDlgItem(IDC_STATIC_NODEVICE)->ShowWindow(SW_HIDE);
			m_pCards->ShowWindow(SW_SHOW);
		}
		else
		{
			GetDlgItem(IDC_STATIC_NODEVICE)->ShowWindow(SW_SHOW);
			m_pCards->ShowWindow(SW_HIDE);
		}
	}
	TRACE("STATUS DISCONNECTED MESSAGE 2\n");
}

void CMiniBoxDevDlg::UpdateStatus(bool fromsocket, int type, int n1, int n2)
{
	TRACE("%x %d %d\n", type, n1, n2);
	switch (type)
	{
	case STATUS_DISCONNECTED:
		{
			TRACE("STATUS DISCONNECTED1\n");
			if (GetSafeHwnd())
			{
				PostMessage(WM_COMMAND, WM_DISCONNECTED);
			}
			TRACE("STATUS DISCONNECTED2\n");
		}break;
	case STATUS_KEY:
		{
			m_pCards->m_pCardLCD->UpdateKeys(n1, n2);
		}break;
	case STATUS_IR:
		{
		}break;
	case STATUS_VER:
		{
			CString strver;
			//if (m_pHIDInterfaceInstall)
			//	strver.Format("%02d.%02d", m_pHIDInterfaceInstall->m_nVersion[0], m_pHIDInterfaceInstall->m_nVersion[1]);
			//else 
				strver.Format("%02d.%02d", m_pHIDInterfaceLCD->m_nVersion[0], m_pHIDInterfaceLCD->m_nVersion[1]);

			SetWindowText(CString(m_pHIDDevLCD->GetDescriptor()->m_sProduct)+" version:"+strver);
		}break;
	case STATUS_ERASE:
		{
			CString str;
			str.Format("Erasing %d from %d",n2,n1);
			if (m_pCards->GetActivePage() == m_pCards->m_pCardFlash)
			{
				m_pCards->m_pCardFlash->m_sAction.SetWindowText(str);
				m_pCards->m_pCardFlash->m_pBar.SetRange(0, n1);
				m_pCards->m_pCardFlash->m_pBar.SetPos(n2);
			}
		}break;
	case STATUS_WRITE:
		{
			CString str;
			str.Format("Writing %d from %d",n2,n1);

			if (m_pCards->GetActivePage() == m_pCards->m_pCardFlash)
			{
				m_pCards->m_pCardFlash->m_sAction.SetWindowText(str);
				m_pCards->m_pCardFlash->m_pBar.SetRange(0, n1);
				m_pCards->m_pCardFlash->m_pBar.SetPos(n2);
			}
		}break;
	case STATUS_READ:
		{
			CString str;
			str.Format("Reading %d from %d",n2,n1);
			if (m_pCards->GetActivePage() == m_pCards->m_pCardFlash)
			{
				m_pCards->m_pCardFlash->m_sAction.SetWindowText(str);
				m_pCards->m_pCardFlash->m_pBar.SetRange(0, n1);
				m_pCards->m_pCardFlash->m_pBar.SetPos(n2);
			}
		}break;
	case STATUS_OK:
		{
			CString str = "OK: UNKNOWN";

			switch (n1)
			{
			case STATUS_ERASE:
				{
					str = "Status: Erasing completed";
				}break;
			case STATUS_WRITE:
				{
					str = "Status: File write completed";
				}break;
			case STATUS_READ:
				{
					str = "Status: Memory read completed";
				}break;
			}

			if (m_pCards->GetActivePage() == m_pCards->m_pCardFlash)
			{
				AfxMessageBox(str);

				m_pCards->m_pCardFlash->m_sAction.SetWindowText("");
				m_pCards->m_pCardFlash->m_pBar.SetPos(0);
			}
		}break;
	case STATUS_ERROR:
		{
			CString str = "ERROR: UNKNOWN";
			switch (n1)
			{
			case STATUS_ERASE:
				{
					str.Format("ERROR: Erasing flash %02x",(n2 & 0xFFFF));
				}break;
			case STATUS_WRITE:
				{
					if (n2 == -100)
						 str.Format("ERROR: File write - Invalid hexfile");
					else str.Format("ERROR: File write %02x",(n2 & 0xFFFF));
				}break;
			case STATUS_READ:
				{
					str.Format("ERROR: Memory read %02x",(n2 & 0xFFFF));
				}break;
			}

			if ((n2 & 0xFFFF0000)==0xFFFF0000)
			{
				switch (n2 & 0xFFFF)
				{
				case 1: str += " (Parameter missing)";break;
				case 2: str += " (Data missing)";break;
				case 3: str += " (Block readonly)";break;
				case 4: str += " (Block not erasable)";break;
				case 5: str += " (Block too big)";break;
				case 6: str += " (Section overflow)";break;
				case 7: str += " (Invalid command length)";break;
				case 8: str += " (Invalid data length)";break;
				}
			}

			if (fromsocket)
				 ;//AddMesg(str+"\n");
			else AfxMessageBox(str);
		}break;
	}
}